---------------------------------------------------------------------
---------- Connecting all of the hooks from this file  --------------
---------------------------------------------------------------------

local function BotPlayerThink(player)

    --Shoot the Bullet projectile
    if(player.spinheld == 1 and player.pflags & PF_STASIS == 0) then
        player.mo.state = S_BULLET_STANCE
    end
    
    if(player.mo.state == S_BULLET_STANCE) then
        
        --Makes sure to display correct sprite depending on whether Jazz is airbone or not
        if(not P_IsObjectOnGround(player.mo)) then
            player.mo.sprite2 = SPR2_BUJU
        elseif(P_IsObjectOnGround(player.mo)) then
            player.mo.sprite2 = SPR2_BUSN
            
            --Skid on the ground
            if(player.speed > 0) then
                SpawnOnSide(player, MT_DUST)
            end
        end

        if(player.bullet_tics >= 0) then
            player.bullet_tics = $-1
        end
        
        if(player.bullet_tics % 5 == 0) then
        
            -- Bullet to be shot
            local bullet = P_SpawnMobjFromMobj(player.mo, 0, 0, 30*FRACUNIT, MT_BULL)
            bullet.target = player.mo
            bullet.angle = player.mo.angle
            
            --Bullet speed
            local bullet_side_speed = P_RandomRange(-3, 3)*FRACUNIT
            local bullet_vertical_speed = P_RandomRange(-3, 3)*FRACUNIT
            local bullet_forward_speed = mobjinfo[bullet.type].speed


            --Shooting the bullet bullet is under water 
            if(bullet.eflags & MFE_UNDERWATER ~= 0) then
                bullet_side_speed = $*2
                bullet_forward_speed = $/2
            end


            -- P_SetObjectMomZ(bullet, bullet_vertical_speed, false)
            P_InstaThrust(bullet, player.mo.angle + ANGLE_90, bullet_side_speed)
            P_Thrust(bullet, player.mo.angle, bullet_forward_speed)

            --Play souund
            S_StartSound(player.mo, sfx_bullet)
        end
    end
    

end

local function BulletMobjThinker(bullet)
    --Underwater spread of the bullet
    if(bullet.eflags & MFE_UNDERWATER) then
        bullet.momx = 9*$/10
        bullet.momy = 9*$/10
    end
end

addHook("PlayerThink", function(player) 
    if(Valid(player.mo, "jazz") and player.tf_mode == TF_MODES.BOT_MODE) then
        BotPlayerThink(player) 
    end
end)

addHook("MobjThinker", function(mo)
    BulletMobjThinker(mo)
end, MT_BULL)