---------------------------------------------------------------------
---------------- Functions and hook definitions  --------------------
---------------------------------------------------------------------


local function TransformationPlayerThink(player)
    if(not Valid(player.mo, "jazz")) then
        return 
    end
    -- print(input.gameControlDown(GC_CUSTOM1))
    -- print(player.jumpspecial == 1)

    --Count down the transformation tics to 0
    if(player.transformation_tics > 0) then
        player.transformation_tics = $-1
    end

    local transform_input = input.gameControlDown(GC_CUSTOM1) or input.gameControlDown(GC_CUSTOM2)

    -- Try to transform if not already transforming 
    if(player.mo.state ~= S_TF_TO_BOT and player.mo.state ~= S_TF_TO_CAR and player.transformation_tics <= 0) then
        -- Transformation from the car mode to the bot mode
        if(player.tf_mode == TF_MODES.CAR_MODE and transform_input) then
            player.mo.state = S_TF_TO_BOT
            S_StopSoundByID(player.mo, sfx_engine)
        -- Transformation from the bot mode to the car mode
        elseif(player.tf_mode == TF_MODES.BOT_MODE and transform_input and player.powers[pw_carry] == 0) then
            player.mo.state = S_TF_TO_CAR
        end 
    end

    -- Execute while in the transformation state
    if(player.mo.state == S_TF_TO_BOT or player.mo.state == S_TF_TO_CAR) then
        player.pflags = $|PF_JUMPSTASIS
    end    
    
end



---------------------------------------------------------------------
---------- Connecting all of the hooks from this file  --------------
---------------------------------------------------------------------


addHook("PlayerThink", function(player) TransformationPlayerThink(player) end)